﻿// ©Copyright 2011 McGee Systems Inc. (dba NetbizSystems.com)
namespace Netbiz.Bizworks

{
    /// <summary>
    /// Bizworks[BaseCaseManager] class
    /// </summary>
    /// <typeparam name="TSubject"></typeparam>
    /// <typeparam name="TApplication"></typeparam>
    public abstract partial class BaseCaseManager<TSubject, TApplication>
        where TSubject : BaseSubjectManager<TApplication>
        where TApplication : BaseApplicationManager
    {
        /// <summary>
        /// Bizworks[BaseCaseManager] constructor
        /// </summary>
        /// <param name="subMan"></param>
        protected BaseCaseManager(TSubject subMan)
        {
            SubjectManager = subMan; // derived classes will love this!
            ApplicationManager = subMan.ApplicationManager; // and this!
        }

        /// <summary>
        /// Bizworks[SubjectManager] reference for this Bizworks[CaseManager]
        /// </summary>
        public readonly TSubject SubjectManager;

        /// <summary>
        /// Bizworks[ApplicationManager] reference for this Bizworks[CaseManager]
        /// </summary>
        public readonly TApplication ApplicationManager;
    }
}
