﻿// ©Copyright 2011 McGee Systems Inc. (dba NetbizSystems.com)
using Munq.LifetimeManagers;
using NLog;

namespace Netbiz.Bizworks
{
    /// <summary>
    /// bizWorks[BaseIocContainer] class
    /// </summary>
    public abstract class BaseIocContainer : Munq.IocContainer 
    {
        /// <summary>
        /// bizWorks[BaseIocContainer] constructor
        /// </summary>
        protected BaseIocContainer(BaseSystemManager bas)
        {
            this.SystemManager = bas;

            base.UsesDefaultLifetimeManagerOf(new ContainerLifetime());

            base.Register<Logger>(c => NLog.LogManager.GetCurrentClassLogger());
            base.Register<BaseFileManager>(c => new BaseFileManager());
            base.Register<BaseSystemManager>(c => bas);
        }

        /// <summary>
        /// bizWorks[BaseIocContainer] constructor (private)
        /// </summary>
        private BaseIocContainer() { }  // do not allow this ;(

        /// <summary>
        /// Bizworks[BaseSystemManager] reference.
        /// </summary>
        public BaseSystemManager SystemManager;

        /// <summary>
        /// Bizworks[BaseApplicationManager] reference
        /// </summary>
        public BaseApplicationManager ApplicationManager { get; protected set; }
    }
}
