﻿using System.Collections.Generic;

namespace Netbiz.Bizworks.Builtins.Admin
{
    /// <summary>
    /// Builtin Bizworks[subjectmanager] for reporting
    /// </summary>
    public partial class AdminSubjectManager<TApplication> : BaseSubjectManager<TApplication> where TApplication : BaseApplicationManager
    {
        /// <summary>
        /// ReportSubjectManager class 
        /// </summary>
        /// <param name="bam"></param>
        public AdminSubjectManager(TApplication bam) : base(bam)
        {
            
        }

        #region Bizworks User Methods
        
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public IList<BizworksUser> GetUsersList()
        {
            var userList = new List<BizworksUser>();

            userList.Add(new BizworksUser() { UserName = "david" });
            userList.Add(new BizworksUser() { UserName = "joseph" });
            userList.Add(new BizworksUser() { UserName = "keith" });
            userList.Add(new BizworksUser() { UserName = "carl" });

            return userList;
        }
        
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public BizworksUser GetUserSingle()
        {
            var userSingle = new BizworksUser() {UserName = "david"};

            return userSingle;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public BizworksUser GetUserByRole(UserRole ur)
        {
            return this.GetUserSingle();
        }
        #endregion

    } // end of class

    /// <summary>
    /// 
    /// </summary>
    public class BizworksUser
    {
        public string UserName { get; set; }
    }

    public enum UserRole
    {
        SysAdministrator = 1,
        BizAdministrator = 2,
        Dba = 3,
        ProductManager = 4
    }
}
