﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Netbiz.Bizworks.Data
{
    /// <summary>
    /// bizworks (xml) model
    /// </summary>
    public partial class BizworksConfigModel : ModelForXml
    {
        /// <summary>
        /// Bizworks[BizworksConfigModel] constructor 
        /// </summary>
        public BizworksConfigModel() : base("BizworksXml") { }
    }

    /// <summary>
    /// repositiry for bizworks XmlMessage
    /// </summary>
    public partial class XmlMessageRepository : BaseRepositoryForXml<XmlMessage>
    {
        public XmlMessageRepository()
        {
            base.XmlFile = "messages.xml";
            base.XmlPath = "//message";
            base.EntityPk = "Id";
        }
    }

    /// <summary>
    /// XmlMessage entity
    /// </summary>
    public class XmlMessage : BaseDtoForXml
    {
        public string Id { get { return base.GetAttributeValue("Id"); } }
        public string MessageText { get { return base.GetAttributeValue("MessageText"); } }

    }
}
