﻿using System.Collections;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Windows.Documents;

namespace Netbiz.Bizworks.Wcf
{
    /// <summary>
    /// Standard datacontract for a simple string
    /// </summary>
    [DataContract]
    public class StringDataContract : BaseDataContract
    {
        [DataMember]
        public string StringValue { get; set; }
    }

    /// <summary>
    /// Standard datacontract for a simple integer
    /// </summary>
    [DataContract]
    public class IntegerDataContract : BaseDataContract
    {
        [DataMember]
        public int IntegerValue { get; set; }
    }

    /// <summary>
    /// Standard datacontract for a simple list
    /// </summary>
    [DataContract]
    public class ListDataContract<T> : BaseDataContract
    {
        public ListDataContract()
        {
            ListValue = new List<T>();
        }
        [DataMember(Name = "ListValue")]
        public List<T> ListValue { get; set; }
    }
}
