﻿using System.Web;
using System.Web.UI;

namespace Netbiz.Bizworks.Web
{
    /// <summary>
    /// 
    /// </summary>
    /// <typeparam name="TControlPresenter">says if we should use the page presenter or create our own</typeparam>
    public abstract class BaseUserControl<TControlPresenter> : UserControl where TControlPresenter : BasePresenter
    {
        protected BaseUserControl(bool pSharedPresenter = true)
        {
            if (!pSharedPresenter)
            {
                //
            }

            var ioc = HttpContext.Current.ApplicationInstance.GetBizworksContainer();
            if (ioc != null)
            {
                PagePresenter = (TControlPresenter)ioc.Resolve(typeof(TControlPresenter));
            }
        }

        void BaseUserControl_Load(object sender, System.EventArgs e) { }

        /// <summary>
        /// Reference to the Bizworks.Presenter for this UI.UserControl
        /// </summary>
        public TControlPresenter PagePresenter { get; private set; }
    }
}
