﻿using System;
using System.Linq;
using Netbiz.Bizworks;
using Netbiz.Bizworks.Wcf;
using Netbiz.Sample.Application.DatabaseModels;

namespace Netbiz.Sample.Application
{
    /// <summary>
    /// SampleApplicationManager(partial) class.  Extends the generated companion (partial)
    /// class as needed for this application.  Members (public/protected) defined in the code-beside 
    /// and its base are available here
    /// </summary>
    public partial class AdventureWorksApplicationManager
    {
        /// <summary>
        /// Initializer (partial) method for this part of the class only
        /// </summary>
        /// <param name="bam"></param>
        partial void InitializeApplicationManager(BaseApplicationManager bam)
        {
            //var xmlConfig = new AdventureWorksModel();

            return; // do setup/initialization as needed
        }

        private AdventureWorksModel _adventureWorksModel = null;
        public AdventureWorksModel AdventureWorksModel
        {
            get
            {
                if (_adventureWorksModel == null)
                {
                    _adventureWorksModel = new AdventureWorksModel();
                }
                return _adventureWorksModel;
            }
        }

        private AdventureWorksXmlModel _adventureWorksXmlModel = null;
        public AdventureWorksXmlModel AdventureWorksXmlModel
        {
            get
            {
                if (_adventureWorksXmlModel == null)
                {
                    _adventureWorksXmlModel = new AdventureWorksXmlModel();
                }
                return _adventureWorksXmlModel;
            }
        }

        #region Application Manager Methods
        /// <summary>
        /// Bizworks application level method for testing
        /// </summary>
        /// <param name="ame"></param>
        /// <returns></returns>
        public EmptyDataContract DoSomething(AuthMethodEnum ame)
        {
            // get a LiveConfig variable
            var notUsed = _LiveConfig.MaxSomething;

            var rtn = new EmptyDataContract();
            try
            {
                using (var ctx = new Sample.DataAccess.AdventureWorksEntities())
                {
                    var qry = from dv in ctx.DomainValues
                              join sam in ctx.Sample1 on dv.dovId equals sam.AuthMethodId
                              where sam.AuthMethodId == (int)ame
                              select new { Sample = sam };

                    var lst = qry.ToList();
                }
            }
            catch (Exception e)
            {
                throw new BaseException(this, e);
            }
            return rtn; // <<<<<<<<<<<<<<<<<
        }
        #endregion
    }
}
