﻿using System;
using System.Linq;
using Netbiz.Bizworks;
using Netbiz.Bizworks.Wcf;

namespace Netbiz.Sample.Application
{
    /// <summary>
    /// CustomerSubjectManager(partial) class.  Extent the generated companion (partial)
    /// class as needed for this subject
    /// </summary>
    public partial class CustomerSubjectManager
    {
        /// <summary>
        /// Initializer (partial) method for this part of the class only
        /// </summary>
        /// <param name="bam"></param>
        partial void InitializeSubjectManager(BaseApplicationManager bam)
        {
            return; // do setup/initialization as needed
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="ame"></param>
        /// <returns></returns>
        public EmptyDataContract DoSomething(AuthMethodEnum ame)
        {
            var rtn = new EmptyDataContract();
            try
            {
                using (var ctx = new Sample.DataAccess.AdventureWorksEntities())
                {
                    var qry = from dv in ctx.DomainValues
                              join sam in ctx.Sample1 on dv.dovId equals sam.AuthMethodId
                              where sam.AuthMethodId == (int)ame
                              select new { Sample = sam };

                    var lst = qry.ToList();
                }
            }
            catch (Exception e)
            {
                throw new Netbiz.Bizworks.BaseException(this.ApplicationManager, e);
            }

            return rtn;
        }
    }
}