﻿using System.Collections.Generic;
using Netbiz.Bizworks;
using Netbiz.Bizworks.Builtins.Report;
using Netbiz.Bizworks.Wcf;

namespace Netbiz.Sample.Application.Presenters
{
    /// <summary>
    /// Bizworks[ReportPresenter] class acts as a proxy into the biz.works layer.  
    /// </summary>
    public partial class ReportPresenter
    {
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public IList<Report1DC> GetReport1Data()
        {
            var biz = (AdventureWorksReports1)BwContainer.Resolve(typeof(AdventureWorksReports1));

            return biz.GetReportData();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public IList<ReportProfile> GetReportProfiles()
        {
            var biz = (AdventureWorksReportManager)BwContainer.Resolve(typeof(AdventureWorksReportManager));

            return biz.GetReportProfileList();
        }
    }
}
