﻿using Netbiz.Bizworks.Wcf;
using Netbiz.Sample.Model;
using Netbiz.Sample.Model.Projects;

namespace Netbiz.Sample.WcfApplication
{
    /// <summary>
    /// Base service for the SampleApplication.  This class exists to make life a bit eaiser
    /// for derived classes.  They could do this (below) stuff themselves but that might present
    /// a maintenance nightmare when framework changes are needed.
    /// </summary>
    public class BaseSampleService : BaseService
    {
        /// <summary>
        /// Constructor for the BaseSampleService.
        /// </summary>
        public BaseSampleService()
        {
            base.SetApplicationManager((SampleApplicationManager)SampleApplicationContainer.Resolve(typeof(SampleApplicationManager)));
        }

        /// <summary>
        /// 
        /// </summary>
        protected static readonly SampleWcfProject SampleWcfProject = new SampleWcfProject();

        /// <summary>
        /// This is the Ioc.Container for the SampleApplication
        /// </summary>
        protected readonly SampleApplicationContainer SampleApplicationContainer = new SampleApplicationContainer(SampleWcfProject);
    }
}
