﻿using System;
using System.ServiceModel.Web;
using System.ServiceModel;
using System.ServiceModel.Activation;
using Netbiz.Bizworks;
using Netbiz.Bizworks.Wcf;
using Netbiz.Sample.Application;

namespace Netbiz.Sample.WcfApplication
{
    /// <summary>
    /// Service interface for the AdventureworksSample.CustomerHome
    /// </summary>
    [ServiceContract(Namespace = "AdventureWorks.Wcf.CustomerHomeService")]
    public partial interface ICustomerHomeService
    {
        [OperationContract, WebGet(ResponseFormat = WebMessageFormat.Json)]
        EmptyDataContract GetEmptyData(EmptyDataContract composite);
    }

// ///////////////////////////////////////////////////////////////////////////////////////////CLASS

    /// <summary>
    /// Service implementation for the AdventureworksSample.CustomerHome
    /// </summary>
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class CustomerHomeService : BasePresenter, ICustomerHomeService
    {
        /// <summary>
        /// special constructor for unittest
        /// </summary>
        /// <param name="pContainer"></param>
        public CustomerHomeService(BaseIocContainer pContainer = null): base(pContainer)
        {
            _customerBizManager1 = (CustomerBizManager1)base.BwContainer.Resolve(typeof(CustomerBizManager1));
        }
        public CustomerHomeService() : this(null)
        {
            //wcf services need this parameterless constructor           
        }

        /// <summary>
        /// this is where most/all of the biz logic for this service resides
        /// </summary>
        private static CustomerBizManager1 _customerBizManager1;

        #region - INTERFACE (operations) MEMBERS
        public EmptyDataContract GetEmptyData(EmptyDataContract composite)
        {
            var emptyDataContract = new EmptyDataContract();
            try
            {
                var rtn = _customerBizManager1.DoSomething(AuthMethodEnum.Other);
            }
            catch (Exception)
            {
                {
                    return (EmptyDataContract)base.SetReturnDataContract(emptyDataContract, 999, false);
                }
                throw;
            }
            return (EmptyDataContract)base.SetReturnDataContract(emptyDataContract, 1);
        }
        #endregion
    }
}