﻿using System;
using System.Collections.Generic;
using System.ServiceModel.Web;
using System.ServiceModel;
using System.ServiceModel.Activation;
using Netbiz.Bizworks;
using Netbiz.Bizworks.Wcf;
using Netbiz.Sample.Application;

namespace Netbiz.Sample.WcfApplication
{
    [ServiceContract(Namespace = "AdventureWorks.Wcf.HomePageService")]
    public partial interface IHomePageService
    {
        [OperationContract, WebGet(ResponseFormat = WebMessageFormat.Json)]
        EmptyDataContract GetEmptyData(EmptyDataContract composite);

        [OperationContract, WebGet(ResponseFormat = WebMessageFormat.Json)]
        IList<MovieData> GetMovieData(int value);
    }

// ///////////////////////////////////////////////////////////////////////////////////////////CLASS

    /// <summary>
    /// Service implementation for the AdventureworksSample.HomePage
    /// </summary>
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class HomePageService : BasePresenter, IHomePageService
    {
        /// <summary>
        /// special constructor for unittest
        /// </summary>
        /// <param name="pContainer"></param>
        public HomePageService(BaseIocContainer pContainer = null): base(pContainer)
        {
            _customerBizManager1 = (CustomerBizManager1)base.BwContainer.Resolve(typeof(CustomerBizManager1));
        }
        public HomePageService() : this(null)
        {
            //wcf services need this parameterless constructor           
        }

        /// <summary>
        /// this is where most/all of the biz logic for this service resides
        /// </summary>
        private static CustomerBizManager1 _customerBizManager1;

        #region - INTERFACE (operations) MEMBERS
        /// <summary>
        /// 
        /// </summary>
        /// <param name="composite"></param>
        /// <returns></returns>
        public EmptyDataContract GetEmptyData(EmptyDataContract composite)
        {
            //var si = OperationContext.Current.InstanceContext.GetServiceInstance();
            //var rc = OperationContext.Current.RequestContext;

            var emptyDataContract = new EmptyDataContract();
            try
            {
                var rtn = _customerBizManager1.DoSomething(AuthMethodEnum.Other);
            }
            catch (Exception)
            {
                {
                    return (EmptyDataContract)base.SetReturnDataContract(emptyDataContract, 999, false);
                }
                throw;
            }
            return (EmptyDataContract)base.SetReturnDataContract(emptyDataContract, 1);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="value">not being used just yet</param>
        /// <returns></returns>
        public IList<MovieData> GetMovieData(int value)
        {
            IList<MovieData> returnData = new List<MovieData>();

            returnData.Add(new MovieData() { Name = "Packers", ReleaseYear = "2011" });
            returnData.Add(new MovieData() { Name = "Saints", ReleaseYear = "2010" });
            returnData.Add(new MovieData() { Name = "Steelers", ReleaseYear = "2009" });
            returnData.Add(new MovieData() { Name = "Giants", ReleaseYear = "2008" });
            returnData.Add(new MovieData() { Name = "Colts", ReleaseYear = "2007" });
            returnData.Add(new MovieData() { Name = "Steelers", ReleaseYear = "2006" });
            returnData.Add(new MovieData() { Name = "Patriots", ReleaseYear = "2005" });
            returnData.Add(new MovieData() { Name = "Patriots", ReleaseYear = "2004" });
            returnData.Add(new MovieData() { Name = "Buccaneers", ReleaseYear = "2003" });
            returnData.Add(new MovieData() { Name = "Patriots", ReleaseYear = "2002" });

            return returnData;
        }

        #endregion
    }

// ///////////////////////////////////////////////////////////////////////////////////////////CLASS

    public class MovieData
    {
        public string Name { get; set; }
        public string ReleaseYear { get; set; } 
    }
}