﻿using System.Web;

namespace Netbiz.Sample.WebApplication
{
    /// <summary>
    /// FragmentHandler 
    /// </summary>
    public class FragmentHandler : IHttpHandler
    {
        /// <summary>
        /// Process request
        /// </summary>
        /// <param name="context"></param>
        /// <remarks>find requsted page fragment in cache and return it</remarks>
        public void ProcessRequest(HttpContext context)
        {
            context.Response.ContentType = "text/plain";
            var cacheGuid = context.Request.QueryString["callback"] ?? string.Empty;
            if (cacheGuid != string.Empty)
            {
                var html = context.Cache.Get(cacheGuid).ToString();
                context.Response.Write(html);
                context.Cache.Remove(cacheGuid);
            }
        }
        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}