﻿using System;
using System.Web.UI;
using Netbiz.Bizworks.Web;
using Netbiz.Sample.Application.Presenters;

namespace Netbiz.Sample.WebApplication
{
    /// <summary>
    /// Code-behind for the HomePage
    /// </summary>
    public partial class HomePage : BaseWebPage<HomePagePresenter>
    {
        /// <summary>
        /// HomePage constructor.. pass Bizworks.DefaultPageName to basePage
        /// </summary>
        public HomePage() : base(Global.AdventureWorksAspProject.HomePageName) { }

        #region - PAGE LIFE-CYCLE EVENTS
        protected void Page_Load(object sender, EventArgs e)
        {
            if (this.IsPostBack)
            {
                // this uc has its own presenter that the basePage doesn't know about.  so, make sure that
                // events on that presenter get consumed correctly.
                base.RegisterOtherPresenter(this.ucShared1.PagePresenter);
            }
        }
        #endregion

        #region - CONTROL EVENTS
        protected void btnPost_Click(object sender, EventArgs e)
        {
            var rtn = this.PagePresenter.DoSomething();
            this.Label1.InnerText = rtn.Success ? rtn.LoggingId : "presenter returned failure.. see event log";
        }
        #endregion
    }
}
