﻿/// <reference name="MicrosoftAjax.js" />
/// <reference path="../Services/HomePage.svc" />
/// <reference path="../T4Generators/Gen.Intellisense.js" />
/// <reference path="../Scripts/AdventureWorksAspProject.js" />
/// <reference path="../Scripts/bizworks-1.0.0.js" />

var bwRef = null; //convenience reference to script (js) for bizworks
var svcRef = null; //convenience reference to service (svc) for this page
var awRef = null; //convenience reference to script (js) for this application

$(function () {

    bwRef = new Bizworks.Common();
    svcRef = new AdventureWorks.Wcf.CustomerHomeService.ICustomerHomeService();
    awRef = new AdventureWorks.Common(bwRef);

    var isDetails = isOthers = false;

    var ctlDetails = $("#divDetailsTitle");
    var ctlDetailsPanel = $("#divDetailsPanel");
    var ctlOrders = $("#divOrdersTitle");
    var ctlOrdersPanel = $("#divOrdersPanel");
    var ctlOthers = $("#divOthersTitle");
    var ctlOthersPanel = $("#divOthersPanel");
    var ctlSave = $("#MainContent_lvCustomer_btnSave");

    //this is the class that decorates each bw.dataItem
    var dataItemClass = ".BizworksListViewItem";

    // click handler for: SAVE
    $(ctlSave).click(function () {
        $(dataItemClass,ctlDetailsPanel).each(function () {
            bwRef.validateDataItem(this);
        });
        return false;
    });

    // click handler for: ORDERS
    $(ctlOrders).click(function () {
        if (!isDetails) {
            var cid = $(ctlOrdersPanel).attr("CachId"); // bw.attribute
            $(ctlOrdersPanel).load(awRef.cacheHandler() + "?callback=" + cid, { name: cid }, function (content) {
                $(this).hide().fadeIn("slow");
                isDetails = true;
            });
        }
        else { $(ctlOrdersPanel).toggle("slow"); }
        return false;
    })
    // bizworks edit/validation handling for this section
    $(dataItemClass, ctlOrdersPanel).blur(function () {
        return bwRef.validateDataItem(this);
    });

    // click handler for: OTHERS
    $(ctlOthers).click(function () {
        if (!isOthers) {
            var cid = $(ctlOthersPanel).attr("CachId"); // bw.attribute
            $(ctlOthersPanel).load(awRef.cacheHandler() + "?callback=" + cid, { name: cid }, function (content) {
                $(this).hide().fadeIn("slow");
                isOthers = true;
            });
        }
        else {
            $(ctlOthersPanel).toggle("slow");
        }
        return false;
    })
    // bizworks edit/validation handling for this section
    $(dataItemClass, ctlOthersPanel).blur(function () {
        return bwRef.validateDataItem(this);
    });

    // click handler for: DETAILS
    $(ctlDetails).click(function () {
        $("#panDetails").toggle("slow");
        return false;
    })
    // bizworks edit/validation handling for this section
    $(dataItemClass, ctlDetailsPanel).blur(function () {
        return bwRef.validateDataItem(this);
    });

});