﻿/// <reference path="../T4Generators/Gen.Intellisense.js" />
/// <reference name="MicrosoftAjax.js" />
/// <reference path="../Services/HomePage.svc" />

var bwRef = null; //convenience reference to script (js) for bizworks
var svcRef = null;  //convenience reference to service (svc) for this page
var awRef = null; //convenience reference to script (js) for this application

$(function () {

    bwRef = new Bizworks.Common();
    svcRef = new AdventureWorks.Wcf.HomePageService.IHomePageService();
    awRef = new AdventureWorks.Common(bwRef);

    svcRef.set_defaultSucceededCallback(myCallback);
    svcRef.set_defaultFailedCallback(awRef.handleServiceFault);

    //get the team data from wcf.service
    svcRef.set_defaultUserContext("GetMovieData");
    svcRef.GetMovieData(123);

    // setup button click
    $('#btnRunService').click(function () {
        var dcEmpty = new Netbiz.Bizworks.Wcf.EmptyDataContract();
        dcEmpty.ForceNoCache = new Date(); // force call
        svcRef.set_defaultUserContext("EmptyDataContract");
        svcRef.GetEmptyData(dcEmpty);
        return false;
    });
});

// ////////////////////////////////////////////////////////////////////////////////////////////////
function myCallback(serviceResult, userContext, methodName) {
    if (userContext == "EmptyDataContract") {
        $('#lblFeedback').text(serviceResult.LoggingId);
    }
    if (userContext == "GetMovieData") {

        var movies = serviceResult.ListValue ;

//        // Compile the markup as a named template
//        $.template("movieTemplate", "<li><b>${Name}</b> (${ReleaseYear})</li>");
//        // Render the template with the movies data 
//        $.tmpl("movieTemplate", movies).appendTo("#movieList");

        // Or, render using inline template
        $("#movieTemplate").tmpl(movies).appendTo("#movieList");
    }
}
