﻿using System;
using System.Web.UI.WebControls;
using Netbiz.Bizworks.Data;
using Netbiz.Bizworks.Web;
using Netbiz.Sample.Application.Presenters;

namespace Netbiz.Sample.WebApplication
{
    /// <summary>
    /// Customer-Details webPage (from baseWebPage)
    /// </summary>
    /// <remarks>base webPage needs to know presenter class</remarks>
    public partial class CustomerDetails : BaseWebPage<CustomerHomePresenter>
    {
        /// <summary>
        /// Customer-Details constructor
        /// </summary>
        /// <remarks>pass bw.page properties to baseWebPage</remarks>
        public CustomerDetails() : base(Global.AdventureWorksAspProject.CustomerDetailPageName) { }

        public const string CUSTOMER_ID = "CustomerId";

        #region - PAGE LIFE-CYCLE EVENTS ----------------------------------------------------------
        protected void Page_Load(object sender, EventArgs e)
        {
            base.SetManualRender(divOrdersPanel);
            base.SetManualRender(divOthersPanel);

            if (!this.IsPostBack)
            {
                this.Title = string.Format("{0} [{1}]", this.Title, Request.QueryString[CUSTOMER_ID]);
            }
        }
        #endregion --------------------------------------------------------------------------------

        /// <summary>
        /// Get Navigate URL
        /// </summary>
        /// <param name="pCustomerId"></param>
        /// <returns>URL+querystring for this page</returns>
        public static string GetNavigateUrl(object pCustomerId)
        {
            return string.Format("CustomerDetails.aspx?{0}={1}", CUSTOMER_ID, pCustomerId);
        }
    }
}