﻿// ©Copyright 2011 McGee Systems Inc. (dba NetbizSystems.com)
using System.Windows;
using Netbiz.Sample.Application;
using Netbiz.Sample.Application.Presenters;
using Netbiz.Sample.Application.Projects;

namespace Netbiz.Sample.WpfApp
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : System.Windows.Application
    {
        void App_Startup(object sender, StartupEventArgs e)
        {
            // register presenters used by this application
            AdventureWorksApplicationContainer.Register<AdminHomePresenter>(c => new AdminHomePresenter(AdventureWorksApplicationContainer));

            // Application is running
            // Process command line args
            bool startMinimized = false;
            for (int i = 0; i != e.Args.Length; ++i)
            {
                if (e.Args[i] == "/StartMinimized")
                {
                    startMinimized = true;
                }
            }

            // Create main application window, starting minimized if specified
            var mainWindow = new MainWindow();
            if (startMinimized)
            {
                mainWindow.WindowState = WindowState.Minimized;
            }
            mainWindow.Show();
        }


        /// <summary>
        ///
        /// </summary>
        public static readonly AdventureWorksApplicationContainer AdventureWorksApplicationContainer = new AdventureWorksApplicationContainer(new AdventureWorksWpfProject());

        /// <summary>
        /// Bizworks[] reference (for convienience)
        /// </summary>
        public static AdventureWorksWpfProject AdventureWorksWpfProject
        {
            get { return (AdventureWorksWpfProject)AdventureWorksApplicationContainer.SystemManager; }
        }
    }

}
