﻿using System.Windows;
using Netbiz.Sample.Application;
using Netbiz.Sample.Application.Presenters;

namespace Netbiz.Sample.WpfApp
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml.  Check .xaml to see how the basepage is implemented.
    /// </summary>
    public partial class MainWindow
    {
        /// <summary>
        /// 
        /// </summary>
        public MainWindow() : base(App.AdventureWorksApplicationContainer, App.AdventureWorksWpfProject.HomePageName)
        {
            InitializeComponent();

            _presenter = (AdminHomePresenter)BaseIocContainer.Resolve(typeof(AdminHomePresenter));

            this.DataContext = _presenter.DoSomething();
        }

        /// <summary>
        /// Reference to the Bizworks[presenter] for this window
        /// </summary>
        private readonly AdminHomePresenter _presenter = null;

        /// <summary>
        /// Button click - run a presenter method
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Button1Click(object sender, RoutedEventArgs e)
        {
            this.DataContext = _presenter.DoSomething();
        }
    }
}
