USE [AdventureWorksLT2008]
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- ------------------------------------------------------------------------------------------------
CREATE SCHEMA NetBiz AUTHORIZATION dbo
GO

-- ------------------------------------------------------------------------------------------------
CREATE TABLE Bizworks.Domain( domId int NOT NULL,domName nvarchar(25) NOT NULL,domDesc nvarchar(max) NOT NULL,domIsEnum bit NOT NULL,domWhenAdded datetime NOT NULL,domWhenChanged datetime NULL,domVersion timestamp NOT NULL, 
CONSTRAINT PK_Domain PRIMARY KEY CLUSTERED (	domId ASC )
WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO

-- ------------------------------------------------------------------------------------------------
CREATE TABLE Bizworks.DomainValues(	dovId int NOT NULL,	dovCode nchar(10) NOT NULL,	dovWhenAdded datetime NOT NULL,	dovWhenChanged datetime NULL,	dovVersion timestamp NOT NULL,	domId_FK int NOT NULL,
CONSTRAINT PK_DomainValues PRIMARY KEY CLUSTERED (	dovId ASC)
WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
ALTER TABLE NetBiz.DomainValues  WITH CHECK ADD  CONSTRAINT FK_DomainValues_Domain FOREIGN KEY(domId_FK)
REFERENCES NetBiz.Domain (domId)
GO
ALTER TABLE NetBiz.DomainValues CHECK CONSTRAINT FK_DomainValues_Domain
GO

-- ------------------------------------------------------------------------------------------------
CREATE TABLE Bizworks.LiveConfig(	dovId int NOT NULL,	lpvId nchar(25) NOT NULL,	lpvVariableName nchar(25) NOT NULL,	lpvVariableValue nvarchar(max) NOT NULL,	lpvVersion timestamp NOT NULL,	lpvWhenAdded datetime NOT NULL,	lpvWhenChanged datetime NULL,
CONSTRAINT PK_LiveConfigs PRIMARY KEY CLUSTERED (	dovId ASC,	lpvId ASC,	lpvVariableName ASC )
WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
ALTER TABLE NetBiz.LiveConfig  WITH CHECK ADD  CONSTRAINT FK_LiveConfigs_DomainValues FOREIGN KEY(dovId)
REFERENCES NetBiz.DomainValues (dovId)
GO
ALTER TABLE NetBiz.LiveConfig CHECK CONSTRAINT FK_LiveConfigs_DomainValues
GO

-- ------------------------------------------------------------------------------------------------
CREATE TABLE Bizworks.Sample1( 	samId int IDENTITY(1,1) NOT NULL,	samName nchar(10) NOT NULL,	AuthMethodId int NOT NULL, samCustom [xml] NULL,
CONSTRAINT PK_Sample1 PRIMARY KEY CLUSTERED (	samId ASC)
WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY]
GO
ALTER TABLE Bizworks.Sample1  WITH CHECK ADD  CONSTRAINT FK_Sample1_DomainValues FOREIGN KEY(AuthMethodId)
REFERENCES Bizworks.DomainValues (dovId)
GO
ALTER TABLE Bizworks.Sample1 CHECK CONSTRAINT FK_Sample1_DomainValues
GO

-- -------------------------------------------------------------------------------------------------
CREATE VIEW [Sample1XML] AS
SELECT     
samId, 
samCustom.value('(//custom/a/text())[1]', 'nvarchar(50)') AS CustomA, 
samCustom.value('(//custom/b/text())[1]', 'nvarchar(50)') AS CustomB
FROM Bizworks.Sample1
GO






